SoTabBoxDragger Class Reference
Dragger Classes

The SoTabBoxDragger wraps a box around geometry you can then translate and scale. More...

`#include <Inventor/draggers/SoTabBoxDragger.h>`

Inheritance diagram for SoTabBoxDragger:

## Public Member Functions

virtual SoType | getTypeId (void) const
virtual const SoNodekitCatalog * | getNodekitCatalog (void) const
| SoTabBoxDragger (void)
void | adjustScaleTabSize (void)
Public Member Functions inherited from SoDragger
virtual void | callback (SoCallbackAction *action)
virtual void | GLRender (SoGLRenderAction *action)
virtual void | getMatrix (SoGetMatrixAction *action)
virtual void | rayPick (SoRayPickAction *action)
virtual void | search (SoSearchAction *action)
virtual void | write (SoWriteAction *action)
virtual void | getPrimitiveCount (SoGetPrimitiveCountAction *action)
void | setProjectorEpsilon (const float epsilon)
float | getProjectorEpsilon (void) const
void | addStartCallback (SoDraggerCB *func, void *data=NULL)
void | removeStartCallback (SoDraggerCB *func, void *data=NULL)
void | addMotionCallback (SoDraggerCB *func, void *data=NULL)
void | removeMotionCallback (SoDraggerCB *func, void *data=NULL)
void | addFinishCallback (SoDraggerCB *func, void *data=NULL)
void | removeFinishCallback (SoDraggerCB *func, void *data=NULL)
void | addValueChangedCallback (SoDraggerCB *func, void *data=NULL)
void | removeValueChangedCallback (SoDraggerCB *func, void *data=NULL)
void | setMinGesture (int pixels)
int | getMinGesture (void) const
SbBool | enableValueChangedCallbacks (SbBool newval)
const SbMatrix & | getMotionMatrix (void)
void | addOtherEventCallback (SoDraggerCB *func, void *data=NULL)
void | removeOtherEventCallback (SoDraggerCB *func, void *data=NULL)
void | registerChildDragger (SoDragger *child)
void | unregisterChildDragger (SoDragger *child)
void | registerChildDraggerMovingIndependently (SoDragger *child)
void | unregisterChildDraggerMovingIndependently (SoDragger *child)
SbMatrix | getLocalToWorldMatrix (void)
SbMatrix | getWorldToLocalMatrix (void)
SbVec3f | getLocalStartingPoint (void)
SbVec3f | getWorldStartingPoint (void)
void | getPartToLocalMatrix (const SbName &partname, SbMatrix &parttolocalmatrix, SbMatrix &localtopartmatrix)
void | transformMatrixLocalToWorld (const SbMatrix &frommatrix, SbMatrix &tomatrix)
void | transformMatrixWorldToLocal (const SbMatrix &frommatrix, SbMatrix &tomatrix)
void | transformMatrixToLocalSpace (const SbMatrix &frommatrix, SbMatrix &tomatrix, const SbName &fromspacepartname)
virtual void | setMotionMatrix (const SbMatrix &newmatrix)
void | valueChanged (void)
const SbMatrix & | getStartMotionMatrix (void)
virtual void | saveStartParameters (void)
const SoPath * | getPickPath (void) const
const SoEvent * | getEvent (void) const
SoPath * | createPathToThis (void)
const SoPath * | getSurrogatePartPickedOwner (void) const
const SbName & | getSurrogatePartPickedName (void) const
const SoPath * | getSurrogatePartPickedPath (void) const
void | setStartingPoint (const SoPickedPoint *newpoint)
void | setStartingPoint (const SbVec3f &newpoint)
const SbViewVolume & | getViewVolume (void)
void | setViewVolume (const SbViewVolume &vol)
const SbViewportRegion & | getViewportRegion (void)
void | setViewportRegion (const SbViewportRegion &reg)
SoHandleEventAction * | getHandleEventAction (void) const
void | setHandleEventAction (SoHandleEventAction *newAction)
void | setTempPathToThis (const SoPath *somethingclose)
virtual void | grabEventsSetup (void)
virtual void | grabEventsCleanup (void)
void | workFieldsIntoTransform (SbMatrix &mtx)
void | setFrontOnProjector (ProjectorFrontSetting newval)
ProjectorFrontSetting | getFrontOnProjector (void) const
Public Member Functions inherited from SoInteractionKit
| SoInteractionKit (void)
virtual SbBool | setPartAsPath (const SbName &partname, SoPath *path)
virtual SbBool | setPartAsDefault (const SbName &partname, SoNode *node, SbBool onlyifdefault=TRUE)
virtual SbBool | setPartAsDefault (const SbName &partname, const SbName &nodename, SbBool onlyifdefault=TRUE)
SbBool | isPathSurrogateInMySubgraph (const SoPath *path, SoPath *&pathToOwner, SbName &surrogatename, SoPath *&surrogatepath, SbBool fillargs=TRUE)
SbBool | isPathSurrogateInMySubgraph (const SoPath *path)
virtual SbBool | setPart (const SbName &partname, SoNode *from)
Public Member Functions inherited from SoBaseKit
| SoBaseKit (void)
virtual SoNode * | getPart (const SbName &partname, SbBool makeifneeded)
SbString | getPartString (const SoBase *part)
virtual SoNodeKitPath * | createPathToPart (const SbName &partname, SbBool makeifneeded, const SoPath *pathtoextend=NULL)
SbBool | set (const char *namevaluepairliststring)
SbBool | set (const char *partnamestring, const char *parameterstring)
virtual void | doAction (SoAction *action)
virtual SoChildList * | getChildren (void) const
void | printDiagram (void)
void | printSubDiagram (const SbName &rootname, int level)
void | printTable (void)
virtual void | addWriteReference (SoOutput *out, SbBool isfromfield=FALSE)
SbBool | forceChildDrivenWriteRefs (SoOutput *out)
Public Member Functions inherited from SoNode
void | setOverride (const SbBool state)
SbBool | isOverride (void) const
void | setNodeType (const NodeType type)
NodeType | getNodeType (void) const
virtual SoNode * | copy (SbBool copyconnections=FALSE) const
virtual SbBool | affectsState (void) const
virtual void | GLRenderBelowPath (SoGLRenderAction *action)
virtual void | GLRenderInPath (SoGLRenderAction *action)
virtual void | GLRenderOffPath (SoGLRenderAction *action)
virtual void | pick (SoPickAction *action)
virtual void | audioRender (SoAudioRenderAction *action)
virtual void | startNotify (void)
virtual void | notify (SoNotList *l)
SbUniqueId | getNodeId (void) const
virtual void | writeInstance (SoOutput *out)
virtual SoFieldContainer * | copyThroughConnection (void) const
Public Member Functions inherited from SoFieldContainer
void | setToDefaults (void)
SbBool | hasDefaultValues (void) const
SbBool | fieldsAreEqual (const SoFieldContainer *container) const
void | copyFieldValues (const SoFieldContainer *container, SbBool copyconnections=FALSE)
SbBool | set (const char *const fielddata)
void | get (SbString &fielddata)
virtual int | getFields (SoFieldList &l) const
virtual int | getAllFields (SoFieldList &l) const
virtual SoField * | getField (const SbName &name) const
virtual SoField * | getEventIn (const SbName &name) const
virtual SoField * | getEventOut (const SbName &name) const
SbBool | getFieldName (const SoField *const field, SbName &name) const
SbBool | enableNotify (const SbBool flag)
SbBool | isNotifyEnabled (void) const
SbBool | set (const char *fielddata, SoInput *input)
void | get (SbString &fielddata, SoOutput *out)
virtual SbBool | validateNewFieldValue (SoField *field, void *newval)
SbBool | getIsBuiltIn (void) const
virtual void | getFieldsMemorySize (size_t &managed, size_t &unmanaged) const
void | setUserData (void *userdata) const
void * | getUserData (void) const
Public Member Functions inherited from SoBase
void | ref (void) const
void | unref (void) const
void | unrefNoDelete (void) const
int32_t | getRefCount (void) const
void | touch (void)
SbBool | isOfType (SoType type) const
| Returns `TRUE` if the type of this object is either of the same type or inherited from type.
virtual SbName | getName (void) const
virtual void | setName (const SbName &newname)
void | addAuditor (void *const auditor, const SoNotRec::Type type)
void | removeAuditor (void *const auditor, const SoNotRec::Type type)
const SoAuditorList & | getAuditors (void) const
SbBool | shouldWrite (void)
void | assertAlive (void) const

## Static Public Member Functions

static SoType | getClassTypeId (void)
static const SoNodekitCatalog * | getClassNodekitCatalog (void)
static void | initClass (void)
Static Public Member Functions inherited from SoDragger
static SoType | getClassTypeId (void)
static const SoNodekitCatalog * | getClassNodekitCatalog (void)
static void | setMinScale (float newminscale)
static float | getMinScale (void)
static void | workValuesIntoTransform (SbMatrix &mtx, const SbVec3f *translationptr, const SbRotation *rotationptr, const SbVec3f *scalefactorptr, const SbRotation *scaleorientationptr, const SbVec3f *centerptr)
static void | getTransformFast (SbMatrix &mtx, SbVec3f &translation, SbRotation &rotation, SbVec3f &scalefactor, SbRotation &scaleorientation, const SbVec3f &center)
static void | getTransformFast (SbMatrix &mtx, SbVec3f &translation, SbRotation &rotation, SbVec3f &scalefactor, SbRotation &scaleorientation)
static SbMatrix | appendTranslation (const SbMatrix &mtx, const SbVec3f &translation, const SbMatrix *conversion=NULL)
static SbMatrix | appendScale (const SbMatrix &mtx, const SbVec3f &scale, const SbVec3f &scalecenter, const SbMatrix *conversion=NULL)
static SbMatrix | appendRotation (const SbMatrix &mtx, const SbRotation &rot, const SbVec3f &rotcenter, const SbMatrix *conversion=NULL)
static void | initClass (void)
static void | initClasses (void)
Static Public Member Functions inherited from SoInteractionKit
static SoType | getClassTypeId (void)
static const SoNodekitCatalog * | getClassNodekitCatalog (void)
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static void | setSwitchValue (SoNode *node, const int newVal)
Static Public Member Functions inherited from SoBaseKit
static SoType | getClassTypeId (void)
static void | initClass (void)
static const SoNodekitCatalog * | getClassNodekitCatalog (void)
static SbBool | isSearchingChildren (void)
static void | setSearchingChildren (const SbBool newval)
Static Public Member Functions inherited from SoNode
static uint32_t | getCompatibilityTypes (const SoType &nodetype)
static SoType | getClassTypeId (void)
static SoNode * | getByName (const SbName &name)
static int | getByName (const SbName &name, SoNodeList &l)
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static void | initClasses (void)
static SbUniqueId | getNextNodeId (void)
static int | getActionMethodIndex (const SoType type)
static void | getBoundingBoxS (SoAction *action, SoNode *node)
static void | GLRenderS (SoAction *action, SoNode *node)
static void | callbackS (SoAction *action, SoNode *node)
static void | getMatrixS (SoAction *action, SoNode *node)
static void | handleEventS (SoAction *action, SoNode *node)
static void | pickS (SoAction *action, SoNode *node)
static void | rayPickS (SoAction *action, SoNode *node)
static void | searchS (SoAction *action, SoNode *node)
static void | writeS (SoAction *action, SoNode *node)
static void | audioRenderS (SoAction *action, SoNode *node)
static void | getPrimitiveCountS (SoAction *action, SoNode *node)
Static Public Member Functions inherited from SoFieldContainer
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static SoType | getClassTypeId (void)
| This static method returns the SoType object associated with objects of this class.
static void | cleanupClass (void)
static void | initCopyDict (void)
static void | addCopy (const SoFieldContainer *orig, const SoFieldContainer *copy)
static SoFieldContainer * | checkCopy (const SoFieldContainer *orig)
static SoFieldContainer * | findCopy (const SoFieldContainer *orig, const SbBool copyconnections)
static void | copyDone (void)
Static Public Member Functions inherited from SoBase
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static SoType | getClassTypeId (void)
| This static method returns the SoType object associated with objects of this class.
static void | addName (SoBase *const base, const char *const name)
static void | removeName (SoBase *const base, const char *const name)
static void | incrementCurrentWriteCounter (void)
static void | decrementCurrentWriteCounter (void)
static SoBase * | getNamedBase (const SbName &name, SoType type)
static int | getNamedBases (const SbName &name, SoBaseList &baselist, SoType type)
static SbBool | read (SoInput *input, SoBase *&base, SoType expectedtype)
static void | setInstancePrefix (const SbString &c)
static void | setTraceRefs (SbBool trace)
static SbBool | getTraceRefs (void)
static SbBool | connectRoute (SoInput *input, const SbName &fromnodename, const SbName &fromfieldname, const SbName &tonodename, const SbName &tofieldname)
static SbBool | readRoute (SoInput *input)

## Public Attributes

SoSFVec3f | translation
SoSFVec3f | scaleFactor
Public Attributes inherited from SoDragger
SoSFBool | isActive
Public Attributes inherited from SoInteractionKit
SoSFEnum | renderCaching
SoSFEnum | boundingBoxCaching
SoSFEnum | renderCulling
SoSFEnum | pickCulling

## Protected Member Functions

virtual const SoFieldData * | getFieldData (void) const
virtual | ~SoTabBoxDragger (void)
virtual SbBool | setUpConnections (SbBool onoff, SbBool doitalways=FALSE)
virtual void | setDefaultOnNonWritingFields (void)
Protected Member Functions inherited from SoDragger
| SoDragger (void)
virtual | ~SoDragger (void)
SbVec2f | getNormalizedLocaterPosition (void)
SbVec2s | getLocaterPosition (void)
SbVec2s | getStartLocaterPosition (void) const
void | setStartLocaterPosition (SbVec2s p)
SbBool | isAdequateConstraintMotion (void)
virtual SbBool | shouldGrabBasedOnSurrogate (const SoPath *pickpath, const SoPath *surrogatepath)
void | setCameraInfo (SoAction *action)
virtual void | handleEvent (SoHandleEventAction *ha)
void | transferMotion (SoDragger *child)
void | setIgnoreInBbox (SbBool newval)
SbBool | isIgnoreInBbox (void)
virtual void | getBoundingBox (SoGetBoundingBoxAction *action)
void | setActiveChildDragger (SoDragger *newchilddragger)
SoDragger * | getActiveChildDragger (void) const
void | updateDraggerCache (const SoPath *path)
virtual const SoPickedPoint * | getPickedPointForStart (SoHandleEventAction *action)
Protected Member Functions inherited from SoInteractionKit
virtual | ~SoInteractionKit ()
virtual void | copyContents (const SoFieldContainer *fromFC, SbBool copyConnections)
virtual SbBool | setPart (const int partNum, SoNode *node)
virtual SbBool | readInstance (SoInput *in, unsigned short flags)
virtual SbBool | setAnyPartAsDefault (const SbName &partname, SoNode *node, SbBool anypart=TRUE, SbBool onlyifdefault=TRUE)
virtual SbBool | setAnyPartAsDefault (const SbName &partname, const SbName &nodename, SbBool anypart=TRUE, SbBool onlyifdefault=TRUE)
SbBool | setAnySurrogatePath (const SbName &name, SoPath *path, SbBool leafcheck=FALSE, SbBool publiccheck=FALSE)
void | connectSeparatorFields (SoSeparator *dest, SbBool onOff)
Protected Member Functions inherited from SoBaseKit
virtual | ~SoBaseKit ()
virtual SoNode * | addToCopyDict (void) const
SoGroup * | getContainerNode (const SbName &listname, SbBool makeifneeded=TRUE)
virtual SoNode * | getAnyPart (const SbName &partname, SbBool makeifneeded, SbBool leafcheck=FALSE, SbBool publiccheck=FALSE)
virtual SoNodeKitPath * | createPathToAnyPart (const SbName &partname, SbBool makeifneeded, SbBool leafcheck=FALSE, SbBool publiccheck=FALSE, const SoPath *pathtoextend=NULL)
virtual SbBool | setAnyPart (const SbName &partname, SoNode *from, SbBool anypart=TRUE)
void | createNodekitPartsList (void)
void | createFieldList (void)
virtual void | createDefaultParts (void)
const SoNodekitParts * | getNodekitPartsList (void) const
const SbList< SoSFNode * > & | getCatalogInstances (void) const
void | catalogError (void)
void | countMyFields (SoOutput *out)
Protected Member Functions inherited from SoNode
| SoNode (void)
virtual | ~SoNode ()
Protected Member Functions inherited from SoFieldContainer
| SoFieldContainer (void)
virtual | ~SoFieldContainer ()
Protected Member Functions inherited from SoBase
| SoBase (void)
virtual | ~SoBase ()
virtual void | destroy (void)
SbBool | hasMultipleWriteRefs (void) const
SbBool | writeHeader (SoOutput *out, SbBool isgroup, SbBool isengine) const
void | writeFooter (SoOutput *out) const
virtual const char * | getFileFormatName (void) const
virtual SoNotRec | createNotRec (void)

## Static Protected Member Functions

static const SoFieldData ** | getFieldDataPtr (void)
static const SoNodekitCatalog ** | getClassNodekitCatalogPtr (void)
static void | invalidateSurroundScaleCB (void *f, SoDragger *d)
static void | fieldSensorCB (void *f, SoSensor *s)
static void | valueChangedCB (void *f, SoDragger *d)
Static Protected Member Functions inherited from SoDragger
static const SoFieldData ** | getFieldDataPtr (void)
static const SoNodekitCatalog ** | getClassNodekitCatalogPtr (void)
static void | childTransferMotionAndValueChangedCB (void *, SoDragger *)
static void | childValueChangedCB (void *, SoDragger *)
static void | childStartCB (void *, SoDragger *)
static void | childMotionCB (void *, SoDragger *)
static void | childFinishCB (void *, SoDragger *)
static void | childOtherEventCB (void *, SoDragger *)
Static Protected Member Functions inherited from SoInteractionKit
static const SoFieldData ** | getFieldDataPtr (void)
static const SoNodekitCatalog ** | getClassNodekitCatalogPtr (void)
static void | readDefaultParts (const char *fileName, const char defaultBuffer[], int defBufSize)
static void | fieldSensorCB (void *, SoSensor *)
Static Protected Member Functions inherited from SoBaseKit
static const SoFieldData ** | getFieldDataPtr (void)
static const SoNodekitCatalog ** | getClassNodekitCatalogPtr (void)
Static Protected Member Functions inherited from SoNode
static const SoFieldData ** | getFieldDataPtr (void)
static void | setNextActionMethodIndex (int index)
static int | getNextActionMethodIndex (void)
static void | incNextActionMethodIndex (void)
static void | setCompatibilityTypes (const SoType &nodetype, const uint32_t bitmask)
Static Protected Member Functions inherited from SoBase
static uint32_t | getCurrentWriteCounter (void)
static void | staticDataLock (void)
static void | staticDataUnlock (void)

## Protected Attributes

SoSFNode | boxGeom
SoSFNode | surroundScale
SoSFNode | tabPlane1
SoSFNode | tabPlane1Sep
SoSFNode | tabPlane1Xf
SoSFNode | tabPlane2
SoSFNode | tabPlane2Sep
SoSFNode | tabPlane2Xf
SoSFNode | tabPlane3
SoSFNode | tabPlane3Sep
SoSFNode | tabPlane3Xf
SoSFNode | tabPlane4
SoSFNode | tabPlane4Sep
SoSFNode | tabPlane4Xf
SoSFNode | tabPlane5
SoSFNode | tabPlane5Sep
SoSFNode | tabPlane5Xf
SoSFNode | tabPlane6
SoSFNode | tabPlane6Sep
SoSFNode | tabPlane6Xf
SoFieldSensor * | translFieldSensor
SoFieldSensor * | scaleFieldSensor
Protected Attributes inherited from SoDragger
SoSFNode | motionMatrix
Protected Attributes inherited from SoInteractionKit
SoSFNode | geomSeparator
SoSFNode | topSeparator
SoFieldSensor * | fieldSensor
SoSeparator * | oldTopSep
Protected Attributes inherited from SoBaseKit
SoSFNode | callbackList
SoChildList * | children
SbBool | connectionsSetUp
Protected Attributes inherited from SoNode
SbUniqueId | uniqueId
Protected Attributes inherited from SoFieldContainer
SbBool | isBuiltIn

## Additional Inherited Members

Public Types inherited from SoDragger
enum | ProjectorFrontSetting { FRONT , BACK , USE_PICK }
Public Types inherited from SoInteractionKit
enum | CacheEnabled { OFF , ON , AUTO }
Public Types inherited from SoNode

enum

NodeType {
INVENTOR = 0x0000 , VRML1 = 0x0001 , VRML2 = 0x0002 , INVENTOR_1 = 0x0004 ,
INVENTOR_2_0 = 0x0008 , INVENTOR_2_1 = 0x0010 , INVENTOR_2_5 = 0x0020 , INVENTOR_2_6 = 0x0040 ,
COIN_1_0 = 0x0080 , COIN_2_0 = 0x0100 , EXTENSION = 0x0200 , COIN_2_2 = 0x0400 ,
COIN_2_3 = 0x0800 , COIN_2_4 = 0x1000 , INVENTOR_5_0 = 0x2000 , COIN_2_5 = 0x4000 ,
COIN_3_0 = 0x8000 , INVENTOR_6_0 = 0x10000 , COIN_4_0 = 0x20000
}

Protected Types inherited from SoBase
enum | BaseFlags { IS_ENGINE = 0x01 , IS_GROUP = 0x02 }
Static Protected Attributes inherited from SoNode
static SbUniqueId | nextUniqueId = 1
static int | nextActionMethodIndex = 0

## Detailed Description

The SoTabBoxDragger wraps a box around geometry you can then translate and scale.

Here's how the dragger looks with its default geometry in the inactive state:

Screen Shot of Default Dragger

This dragger lets the end-user do translation and non-uniform scaling of geometry with an easy to understand interface.

Click and drag any side of the box to translate (hold down a SHIFT key to lock to one axis) and click and drag any of the tab markers in the corners to scale. The way the different tabs influences the scale operation should be straight-forward and intuitive to the end-user.

The SoTabBoxDragger is a composite dragger, implemented with 6 SoTabPlaneDragger instances set up as the sides of a box.

## Constructor & Destructor Documentation

## SoTabBoxDragger()

SoTabBoxDragger::SoTabBoxDragger | ( | void |  | ) |

Default constructor, sets up the dragger nodekit catalog with the interaction and feedback geometry.

Nodekit structure (new entries versus parent class marked with arrow prefix):

    CLASS SoTabBoxDragger
    -->"this"
          "callbackList"
          "topSeparator"
             "motionMatrix"
    -->      "surroundScale"
    -->      "tabPlane1Sep"
    -->         "tabPlane1Xf"
    -->         "tabPlane1"
    -->      "tabPlane2Sep"
    -->         "tabPlane2Xf"
    -->         "tabPlane2"
    -->      "tabPlane3Sep"
    -->         "tabPlane3Xf"
    -->         "tabPlane3"
    -->      "tabPlane4Sep"
    -->         "tabPlane4Xf"
    -->         "tabPlane4"
    -->      "tabPlane5Sep"
    -->         "tabPlane5Xf"
    -->         "tabPlane5"
    -->      "tabPlane6Sep"
    -->         "tabPlane6Xf"
    -->         "tabPlane6"
             "geomSeparator"
    -->         "boxGeom"

(See SoBaseKit::printDiagram() for information about the output formatting.)

Detailed information on catalog parts:

    CLASS SoTabBoxDragger
    PVT   "this",  SoTabBoxDragger  ---
          "callbackList",  SoNodeKitListPart [ SoCallback, SoEventCallback ]
    PVT   "topSeparator",  SoSeparator  ---
    PVT   "motionMatrix",  SoMatrixTransform  ---
          "surroundScale",  SoSurroundScale  ---
    PVT   "tabPlane1Sep",  SoSeparator  ---
    PVT   "tabPlane1Xf",  SoTransform  ---
          "tabPlane1",  SoTabPlaneDragger  ---
    PVT   "tabPlane2Sep",  SoSeparator  ---
    PVT   "tabPlane2Xf",  SoTransform  ---
          "tabPlane2",  SoTabPlaneDragger  ---
    PVT   "tabPlane3Sep",  SoSeparator  ---
    PVT   "tabPlane3Xf",  SoTransform  ---
          "tabPlane3",  SoTabPlaneDragger  ---
    PVT   "tabPlane4Sep",  SoSeparator  ---
    PVT   "tabPlane4Xf",  SoTransform  ---
          "tabPlane4",  SoTabPlaneDragger  ---
    PVT   "tabPlane5Sep",  SoSeparator  ---
    PVT   "tabPlane5Xf",  SoTransform  ---
          "tabPlane5",  SoTabPlaneDragger  ---
    PVT   "tabPlane6Sep",  SoSeparator  ---
    PVT   "tabPlane6Xf",  SoTransform  ---
          "tabPlane6",  SoTabPlaneDragger  ---
    PVT   "geomSeparator",  SoSeparator  ---
          "boxGeom",  SoSeparator  ---

(See SoBaseKit::printTable() for information about the output formatting.)

## ~SoTabBoxDragger()

SoTabBoxDragger::~SoTabBoxDragger | ( | void |  | ) |

protected virtual

Protected destructor.

(Dragger classes are derived from SoBase, so they are reference counted and automatically destroyed when their reference count goes to 0.)

## Member Function Documentation

## getClassTypeId()

SoType SoTabBoxDragger::getClassTypeId | ( | void |  | ) |

static

This static method returns the SoType object associated with objects of this class.

## getTypeId()

SoType SoTabBoxDragger::getTypeId | ( | void |  | ) | const

virtual

Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and "downward" casting.

Reimplemented from SoDragger.

## getFieldDataPtr()

const SoFieldData ** SoTabBoxDragger::getFieldDataPtr | ( | void |  | ) |

static protected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
Returns the SoFieldData class which holds information about fields in this node.

## getFieldData()

const SoFieldData * SoTabBoxDragger::getFieldData | ( | void |  | ) | const

protected virtual

Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns `NULL`.

Reimplemented from SoDragger.

## getClassNodekitCatalog()

const SoNodekitCatalog * SoTabBoxDragger::getClassNodekitCatalog | ( | void |  | ) |

static

Returns the nodekit catalog which defines the layout of this class' kit.

## getNodekitCatalog()

const SoNodekitCatalog * SoTabBoxDragger::getNodekitCatalog | ( | void |  | ) | const

virtual

Returns the nodekit catalog which defines the layout of this class' kit.

Reimplemented from SoDragger.

## getClassNodekitCatalogPtr()

const SoNodekitCatalog ** SoTabBoxDragger::getClassNodekitCatalogPtr | ( | void |  | ) |

static protected

Returns the pointer to the pointer of the nodekit catalog for this class.

## initClass()

void SoTabBoxDragger::initClass | ( | void |  | ) |

static

Initializes type system for this dragger class.

Application programmers should usually not have to invoke this method, see documentation of SoInteraction::init().

## adjustScaleTabSize()

void SoTabBoxDragger::adjustScaleTabSize | ( | void |  | ) |

Signals the dragger to recalculate the size of its tabs.

Simply calls SoTabPlaneDragger::adjustScaleTabSize() for all 6 planes this dragger consists of.

## setUpConnections()

SbBool SoTabBoxDragger::setUpConnections | ( | SbBool | onoff,
|  | SbBool | doitalways = FALSE )

protected virtual

Sets up all internal connections for instances of this class.

(This method will usually not be of interest to the application programmer, unless you want to extend the library with new custom nodekits or dragger classes. If so, see the SoBaseKit class documentation.)

Reimplemented from SoInteractionKit.

## setDefaultOnNonWritingFields()

void SoTabBoxDragger::setDefaultOnNonWritingFields | ( | void |  | ) |

protected virtual

(Be aware that this method is unlikely to be of interest to the application programmer who does not want to extend the library with new custom nodekits or draggers. If you indeed are writing extensions, see the information in the SoBaseKit class documentation.)

This is a virtual method, and the code in it should call SoField::setDefault() with argument `TRUE` on part fields that should not be written upon scene graph export operations.

This is typically done when:

1. field value is `NULL` and part is `NULL` by default

2. it is a leaf SoGroup or SoSeparator node with no children

3. it is a leaf listpart with no children and an SoGroup or SoSeparator container

4. it is a non-leaf part and it is of SoGroup type and all fields are at their default values

Subclasses should usually override this to do additional settings for new member fields. From the subclass, do remember to call "upwards" to your superclass' setDefaultOnNonWritingFields() method.

Reimplemented from SoDragger.

## invalidateSurroundScaleCB()

void SoTabBoxDragger::invalidateSurroundScaleCB | ( | void * | d,
|  | SoDragger * | d )

static protected

surroundScale is invalidated every time a child dragger is activated/deactivated using this callback

## fieldSensorCB()

void SoTabBoxDragger::fieldSensorCB | ( | void * | d,
|  | SoSensor * | s )

static protected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

## valueChangedCB()

void SoTabBoxDragger::valueChangedCB | ( | void * | f,
|  | SoDragger * | d )

static protected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

## Member Data Documentation

## translation

SoSFVec3f SoTabBoxDragger::translation

Continuously updated to contain the current translation from the dragger's local origo position.

## scaleFactor

SoSFVec3f SoTabBoxDragger::scaleFactor

Continuously updated to contain the current vector of scaling along the X, Y and Z axes.

## translFieldSensor

SoFieldSensor* SoTabBoxDragger::translFieldSensor

protected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

## scaleFieldSensor

SoFieldSensor* SoTabBoxDragger::scaleFieldSensor

protected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

The documentation for this class was generated from the following files:

- SoTabBoxDragger.h
- SoTabBoxDragger.cpp